
User Interface - Bug #2971

Bug # 2677 (New): fix drawing and functional differences between P2J GUI and 4GL GUI

rework tooltip support to use OverlayWindow

01/26/2016 01:21 PM - Greg Shah

Status: New Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category:  Estimated time: 0.00 hour

Target version: Cleanup and Stabilization for GUI   

billable: No case_num:  

vendor_id: GCD   

Description

Related issues:

Related to User Interface - Bug #2837: GUI combo-box drop-down needs to be ab... Closed

Related to User Interface - Feature #4029: implement more widget rendering kn... New

History

#1 - 01/26/2016 01:22 PM - Greg Shah

Tooltips must be contained in an OverlayWindow so that their contents can draw outside of the bounds of the "real" containing window (when

needed).

Please see #2837 for details of how this was resolved for combo-box drop-downs. The same approach should be used here.

#2 - 03/23/2016 05:26 PM - Greg Shah

- Target version changed from Milestone 12 to Milestone 16

#3 - 11/16/2016 12:23 PM - Greg Shah

- Target version changed from Milestone 16 to Cleanup and Stabilization for GUI

#5 - 04/20/2021 07:54 AM - Greg Shah

- Related to Feature #4029: implement more widget rendering knowledge within the client drivers added

#6 - 04/20/2021 07:59 AM - Greg Shah

Although the Swing client does need the overlay window approach, for the web client I think tooltips are an ideal example of a feature which would be

best implemented mostly on the javascript side.  As noted in #4029, the idea is to move the drawing/event processing to javascript while just

synchronizing the state needed to handle this remotely.

The rendering of tooltips is simple, there is no interactive/editing feature and the mouse processing would be much faster without any upcalls. 

Essentially, we would need to maintain a map of the hover locations to their tooltips, based on the z-order in the 4GL.  This state would have to be

synchronized.

#7 - 10/25/2021 07:01 AM - Constantin Asofiei

3821c/13105 solves the problems described in #3981, for Web driver (tooltip for a widget behind another widget, in z-order, must be shown).
https://proj.goldencode.com/issues/2837
https://proj.goldencode.com/issues/4029


There is also another possible problem: OE shows the tooltip regardless of the widget's sensitivity, and also it shows the tooltip for 'the closest widget

in z-order on that location, which has a tooltip'.  There are issues in Swing about this, as AbstractContainer.findMouseSource will ignore non-sensitive

widgets, during the lookup.
